using Indotalent.Data.Entities;
using Indotalent.Shared.Consts;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;

namespace Indotalent.Infrastructure.Database.MsSQL.Configuration;

public class ProgramManagerConfiguration : IEntityTypeConfiguration<ProgramManager>
{
    public void Configure(EntityTypeBuilder<ProgramManager> builder)
    {
        builder.Property(e => e.Title)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.AutoNumber)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.Summary)
            .HasMaxLength(GlobalConsts.StringLengthMedium);

        builder.Property(e => e.ProgramManagerResourceId)
            .HasMaxLength(GlobalConsts.StringLengthId);

        builder.HasOne(e => e.ProgramManagerResource)
            .WithMany()
            .HasForeignKey(e => e.ProgramManagerResourceId)
            .OnDelete(DeleteBehavior.NoAction);

        builder.HasIndex(e => new { e.TenantId, e.Title }).IsUnique();
        builder.HasIndex(e => new { e.TenantId, e.AutoNumber }).IsUnique();
        builder.HasIndex(e => e.ProgramManagerResourceId);
    }
}